
Foreman - Bug #21654

Host discovery fails with undefined method `new` for nil:NIlClass

11/14/2017 09:16 AM - Lukas Zapletal

Status: Closed   

Priority: Normal   

Assignee: Rahul Bajaj   

Category: Facts   

Target version:    

Difficulty: trivial Fixed in Releases: 2.1.0

Triaged: No Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/5010

  

Description

The problem is that in the old (pre-PR) code importers registry is kept in FactImporter class that gets reloaded. Once the class is

reloaded, it looses its default importer registration that point to puppet. See my comment for more information.

This is a regression in the import_facts core codebase introduced by #15409.

Let's add one REAL (non-mocked) test of discovering a host :-)

Related issues:

Related to Discovery - Bug #21653: Unable to render host without memory info Closed 11/14/2017

Related to Katello - Bug #22705: Must use the ImporterRegistry rather than Fa... Closed

Related to Foreman - Bug #21573: Importing facts in development breaks on cod... Duplicate

Related to Foreman - Bug #34026: Importing puppet report via the API does not... Closed

Associated revisions

Revision 5b8e09dc - 03/05/2020 10:58 AM - Rahul Bajaj

Fixes #21654 - create registry for importers

History

#1 - 11/14/2017 09:49 AM - Rahul Bajaj

- Assignee set to Rahul Bajaj

#2 - 11/14/2017 12:14 PM - Lukas Zapletal

- Related to Bug #21653: Unable to render host without memory info added

#3 - 11/15/2017 11:56 AM - Lukas Zapletal

As per IRC, the issue is in Host::Base#import_facts:

type = facts.delete(:_type)

 It was previously:

type = facts.delete(:_type) || 'puppet'

#4 - 02/27/2018 12:12 PM - Rahul Bajaj

- Project changed from Discovery to Foreman

- Category deleted (Discovery plugin)

#5 - 02/27/2018 12:18 PM - Rahul Bajaj

- Pull request https://github.com/theforeman/foreman/pull/5010 added
#6 - 02/27/2018 12:22 PM - Rahul Bajaj

- Related to Bug #22705: Must use the ImporterRegistry rather than FactImporter added

#7 - 02/28/2018 07:43 PM - The Foreman Bot

- Status changed from New to Ready For Testing

#8 - 07/20/2018 08:50 AM - Lukas Zapletal

- Triaged set to No

It looks like this happens only when Rails reloads some classes: #21573

#9 - 07/20/2018 08:50 AM - Lukas Zapletal

- Related to Bug #21573: Importing facts in development breaks on code reload added

#10 - 07/26/2018 10:03 AM - Lukas Zapletal

- Description updated

#11 - 03/05/2020 10:58 AM - The Foreman Bot

- Fixed in Releases 2.1.0 added

#12 - 03/05/2020 11:01 AM - Rahul Bajaj

- Status changed from Ready For Testing to Closed

Applied in changeset 5b8e09dc6a465066bfa2c1bb7a9645cbd7994ce1.

#13 - 05/13/2020 11:31 AM - Tomer Brisker

- Category set to Facts

#14 - 11/29/2021 12:32 PM - Lukas Zapletal

- Related to Bug #34026: Importing puppet report via the API does not authorize added
